/*! \file files.c \brief Suche nach Files für http */
//***************************************************************************
//*            files.c
//*
//*  Sat Jul 13 21:07:42 2008
//*  Copyright  2008  Dirk Broßwick
//*  Email: sharandac@snafu.de
//****************************************************************************/
///	\ingroup software
///	\defgroup files Suche nach Files für http (files.c)
///	\code #include "files.h" \endcode
///	\par Uebersicht
//****************************************************************************/
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA
 */
//@{ 
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/io.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
 
#include "httpd2.h" 
#include "cgi-bin.h"
#include "system/net/tcp.h"
#include "system/stdout/stdout.h"

#include "files.h"
#include "files_data.h"

/*------------------------------------------------------------------------------------------------------------*/
/*!\brief Schick die MP3-Daten zum VS10xx
 * \param 	pStruct		Pointer auf die HTTP Struktur.
 * \return	returncode	-1 Failed, 1 OK, File gefunden
 */
/*------------------------------------------------------------------------------------------------------------*/
int check_files( void * pStruct )
{
	struct HTTP_REQUEST * http_request;
	http_request = (struct HTTP_REQUEST *) pStruct;
		
	int i, returnvalue = -1;
	
	for( i = 0 ; i < MAX_FILES_ENTRYS ; i++ )
	{
		if ( files[ i ].len == 0 )
			break;
		
		if ( !strcmp_P( http_request->GET_FILE, files[ i ].filesname ) )
		{
			printf_P( PSTR("HTTP/1.0 200 Document follows\r\n"
						   "Content-Type: ") );

			switch ( files[ i ].filestype )
			{
				case PNG:					printf_P( PSTR("png\r\n") );
											break;
				case JPEG:					printf_P( PSTR("jpeg\r\n") );
											break;
				case TEXT:					printf_P( PSTR("text/html\r\n") );
											break;
				default:					printf_P( PSTR("bin\r\n") );
			}
	
			printf_P( PSTR(	"Content-Lenght: %d\r\n"
						    "Cache-Control: max-age=3600\r\n"
							"Keep-Alive: close\r\n"
							"\r\n" ), files[ i ].len );

			STDOUT_Flush();
			PutSocketData_RPE( http_request->HTTP_SOCKET, files[ i ].len, ( void * ) files[ i ].files, FLASH );
			returnvalue = 1 ;
			break;
		}
	}
	return( returnvalue );
} 
//}@
